from PyQt4 import QtCore, QtGui
from PyQt4.QtCore import *
from PyQt4.QtGui import *

from pfc_func import *     
                
class kwikKModel(QtCore.QAbstractListModel):
    numberPopulated = QtCore.pyqtSignal(int)
    
    def __init__(self, parent=None):
        super(kwikKModel, self).__init__(parent)

        self.ko = kwikobj()
        
    def rowCount(self, parent=QtCore.QModelIndex()):
        return len(self.ko.kwikList)

    def data(self, index, role=QtCore.Qt.DisplayRole):
        if not index.isValid():
            return None

        if index.row() >= len(self.ko.kwikList) or index.row() < 0:
            return None

        if role == QtCore.Qt.DisplayRole:
            """t = QtGui.QTextDocument()
            t.setHtml(self.ko.kwikList[index.row()])
            return t.toHtml()
            """
            return self.ko.kwikList[index.row()]
        
        return None


class kwikFModel(QtCore.QAbstractListModel):
    numberPopulated = QtCore.pyqtSignal(int)

    def __init__(self, parent=None):
        super(kwikFModel, self).__init__(parent)

        self.ko = kwikobj()
        
    def rowCount(self, parent=QtCore.QModelIndex()):
        return len(self.ko.fileList)

    def data(self, index, role=QtCore.Qt.DisplayRole):
        if not index.isValid():
            return None

        if index.row() >= len(self.ko.fileList) or index.row() < 0:
            return None

        """if role == QtCore.Qt.DisplayRole:
            return self.ko.fileList[index.row()]
				"""
        if role == QtCore.Qt.DisplayRole:
            return self.ko.fileList[index.row()]

        if role == QtCore.Qt.ToolTipRole:
            return self.ko.fileList[index.row()]
				
        return None

        
class hitModel(QtCore.QAbstractListModel):
    numberPopulated = QtCore.pyqtSignal(int)

    def __init__(self, parent=None):
        super(hitModel, self).__init__(parent)

        self.ko = kwikobj()
        
    def rowCount(self, parent=QtCore.QModelIndex()):
        return len(self.ko.fileList)

    def data(self, index, role=QtCore.Qt.DisplayRole):
        if not index.isValid():
            return None

        if index.row() >= len(self.ko.fileList) or index.row() < 0:
            return None

        if role == QtCore.Qt.DisplayRole:
            return index.row()

        return None
        



class WLfreqModel(QtCore.QAbstractListModel):
    numberPopulated = QtCore.pyqtSignal(int)
    
    def __init__(self, parent=None):
        super(WLfreqModel, self).__init__(parent)

        self.wl = wlobj()
        
    def rowCount(self, parent=QtCore.QModelIndex()):
        return len(self.wl.freqList)

    def data(self, index, role=QtCore.Qt.DisplayRole):
        if not index.isValid():
            return None

        if index.row() >= len(self.wl.freqList) or index.row() < 0:
            return None

        if role == QtCore.Qt.DisplayRole:
            return self.wl.freqList[index.row()]
        
        return None


class WLwordModel(QtCore.QAbstractListModel):
    numberPopulated = QtCore.pyqtSignal(int)

    def __init__(self, parent=None):
        super(WLwordModel, self).__init__(parent)

        self.wl = wlobj()
        
    def rowCount(self, parent=QtCore.QModelIndex()):
        return len(self.wl.wordList)

    def data(self, index, role=QtCore.Qt.DisplayRole):
        if not index.isValid():
            return None

        if index.row() >= len(self.wl.wordList) or index.row() < 0:
            return None

        if role == QtCore.Qt.DisplayRole:
            return self.wl.wordList[index.row()]
	
        return None

        
class WLlemmaModel(QtCore.QAbstractListModel):
    numberPopulated = QtCore.pyqtSignal(int)

    def __init__(self, parent=None):
        super(WLlemmaModel, self).__init__(parent)

        self.wl = wlobj()
        
    def rowCount(self, parent=QtCore.QModelIndex()):
        return len(self.wl.lemmaList)

    def data(self, index, role=QtCore.Qt.DisplayRole):
        if not index.isValid():
            return None

        if index.row() >= len(self.wl.lemmaList) or index.row() < 0:
            return None

        if role == QtCore.Qt.DisplayRole:
            return self.wl.lemmaList[index.row()]
	
        return None

        
class WLrankModel(QtCore.QAbstractListModel):
    numberPopulated = QtCore.pyqtSignal(int)

    def __init__(self, parent=None):
        super(WLrankModel, self).__init__(parent)

        self.wl = wlobj()
        
    def rowCount(self, parent=QtCore.QModelIndex()):
        return len(self.wl.wordList)

    def data(self, index, role=QtCore.Qt.DisplayRole):
        if not index.isValid():
            return None

        if index.row() >= len(self.wl.wordList) or index.row() < 0:
            return None

        if role == QtCore.Qt.DisplayRole:
            return index.row()

        return None
        



#Controla el llistat de fitxers (a l'esquerra)
class FileListModel(QtCore.QAbstractListModel):
    numberPopulated = QtCore.pyqtSignal(int)

    def __init__(self, parent=None):
        super(FileListModel, self).__init__(parent)

        self.fileCount = 0
        self.fileList = []

    def rowCount(self, parent=QtCore.QModelIndex()):
        return self.fileCount

    def data(self, index, role=QtCore.Qt.DisplayRole):
        if not index.isValid():
            return None

        if index.row() >= len(self.fileList) or index.row() < 0:
            return None

        if role == QtCore.Qt.DisplayRole:
            return self.fileList[index.row()][self.fileList[index.row()].rfind("/")+1:]

        if role == QtCore.Qt.ToolTipRole:
            return self.fileList[index.row()]

        
        return None

    def canFetchMore(self, index):
        return self.fileCount < len(self.fileList)

    def fetchMore(self, index):
        remainder = len(self.fileList) - self.fileCount
        itemsToFetch = min(99999, remainder)

        self.beginInsertRows(QtCore.QModelIndex(), self.fileCount,
                self.fileCount + itemsToFetch)

        self.fileCount += itemsToFetch

        self.endInsertRows()

        self.numberPopulated.emit(itemsToFetch)

    def setDirPath(self, path):
        dir = QtCore.QDir(path)
        
        dirFiles = list(dir.entryInfoList(["*.txt"],QtCore.QDir.Files,QtCore.QDir.Name))
        for i in range(len(dirFiles)):
            self.fileList.append(str(dirFiles[i].absoluteFilePath()))
            files.addFile(str(dirFiles[i].absoluteFilePath()))

        folders = list(dir.entryInfoList(QtCore.QDir.Dirs,QtCore.QDir.Name))
        for i in range(2,len(folders)):
            if not folders[i].absoluteFilePath().endswith("/..") and not folders[i].absoluteFilePath().endswith("/."):  #Necessari per evitar un error de recursivitat.
                self.setDirPath(folders[i].absoluteFilePath())
    
        self.fileCount = 0
        self.reset()

    def addFile(self, file):
        self.fileList.append(str(file))
        files.addFile(file)
        self.fileCount = 0
        self.reset()
        
    def removeFile(self, pos):
        self.fileList.pop(pos)
        self.fileCount = 0
        files.delFile(pos)
        self.reset()

    def removeAllFiles(self):
        self.fileList = []
        self.fileCount = 0
        files.clear()
        self.reset()
        self.numberPopulated.emit(0)
   
    def findByName(self,name):
        for i in range(len(self.fileList)):
            if self.fileList[i] == name:
                return i
        return False
        
       
       
       
        
#Mostra contingut HTML a les llistes (QListView o QListWidget)        
class HTMLDelegate(QStyledItemDelegate):

    def paint(self, painter, option, index):
        painter.save()

        model = index.model()
        if(model.metaObject().className()=="kwikKModel"):
            record = model.ko.kwikList[index.row()]
        elif(model.metaObject().className()=="kwikFModel"):
            record = model.ko.fileList[index.row()][model.ko.fileList[index.row()].rfind("/")+1:]
        elif(model.metaObject().className()=="hitModel"):
            record = str(index.row())
        doc = QTextDocument(self)

        doc.setHtml(record)
        doc.toPlainText()
        ctx = QAbstractTextDocumentLayout.PaintContext()
        painter.save()
        painter.translate(option.rect.topLeft());
        painter.setClipRect(option.rect.translated(-option.rect.topLeft()))
        dl = doc.documentLayout()
        dl.draw(painter, ctx)
        painter.restore()
        
    def sizeHint(self, option, index):
        model = index.model()
        if(model.metaObject().className()=="kwikKModel"):
            record = model.ko.kwikList[index.row()]
        elif(model.metaObject().className()=="kwikFModel"):
            record = model.ko.fileList[index.row()][model.ko.fileList[index.row()].rfind("/")+1:]
        elif(model.metaObject().className()=="hitModel"):
            record = str(index.row())
        
        doc = QTextDocument(self)
        doc.setHtml(record)
        doc.toPlainText()
        return QSize(doc.idealWidth(), doc.size().height())

