from PyQt4 import QtCore, QtGui
from PyQt4.QtCore import *
from PyQt4.QtGui import *

from About import Ui_About
from GlobalSettings import Ui_GlobalSettings
from ToolPreferences import Ui_ToolPreferences
from AdvancedSearch import Ui_AdvancedSearch

from ConcordancePreferences import Ui_ConcordancePreferences
from CollocatesPreferences import Ui_CollocatesPreferences
from WordListPreferences import Ui_WordListPreferences

from FileSettings import Ui_FileSettings
from TagSettings import Ui_TagSettings
from TokenDefinitionSettings import Ui_TokenDefinitionSettings
from WildcardSettings import Ui_WildcardSettings

class About(QtGui.QWidget):
    def __init__(self):
        QtGui.QWidget.__init__(self)

        self.ventana = Ui_About()
        self.ventana.setupUi(self)
        self.ventana.textEdit.setFocus()


     
class GlobalSettings(QtGui.QWidget):
    class FileSettings(QtGui.QWidget):
        def __init__(self,parent,task=None):
            QtGui.QWidget.__init__(self,parent)
            self.ventana = Ui_FileSettings()
            self.ventana.setupUi(self)
    class TagSettings(QtGui.QWidget):
        def __init__(self,parent,task=None):
            QtGui.QWidget.__init__(self,parent)
            self.ventana = Ui_TagSettings()
            self.ventana.setupUi(self)
    class TokenDefinitionSettings(QtGui.QWidget):
        def __init__(self,parent,task=None):
            QtGui.QWidget.__init__(self,parent)
            self.ventana = Ui_TokenDefinitionSettings()
            self.ventana.setupUi(self)
    class WildcardSettings(QtGui.QWidget):
        def __init__(self,parent,task=None):
            QtGui.QWidget.__init__(self,parent)
            self.ventana = Ui_WildcardSettings()
            self.ventana.setupUi(self)

    def __init__(self):
        QtGui.QWidget.__init__(self)

        self.ventana = Ui_GlobalSettings()
        self.ventana.setupUi(self)
        self.filesettingswin = self.FileSettings(self.ventana.frame)
        self.tagsettingswin = self.TagSettings(self.ventana.frame)
        self.tokendefinitionsettingswin = self.TokenDefinitionSettings(self.ventana.frame)
        self.wildcardsettingswin = self.WildcardSettings(self.ventana.frame)
        self.tagsettingswin.hide()
        self.tokendefinitionsettingswin.hide()
        self.wildcardsettingswin.hide()
        self.ventana.listWidget.setFocus()
        
        self.connect(self.ventana.listWidget, QtCore.SIGNAL('currentRowChanged(int)'), self.changed)

    def changed(self,i):
        if i == 0:
            self.filesettingswin.show()
            self.tagsettingswin.hide()
            self.tokendefinitionsettingswin.hide()
            self.wildcardsettingswin.hide()
        elif i == 1:
            self.filesettingswin.hide()
            self.tagsettingswin.show()
            self.tokendefinitionsettingswin.hide()
            self.wildcardsettingswin.hide()
        elif i == 2:
            self.filesettingswin.hide()
            self.tagsettingswin.hide()
            self.tokendefinitionsettingswin.hide()
            self.wildcardsettingswin.show()
        elif i == 3:
            self.filesettingswin.hide()
            self.tagsettingswin.hide()
            self.tokendefinitionsettingswin.show()
            self.wildcardsettingswin.hide()
        else:
            self.filesettingswin.hide()
            self.tagsettingswin.hide()
            self.tokendefinitionsettingswin.hide()
            self.wildcardsettingswin.hide()
            print("error")
        

        

class ToolPreferences(QtGui.QWidget):
    class ConcordancePreferences(QtGui.QWidget):
        def __init__(self,parent,task=None):
            QtGui.QWidget.__init__(self,parent)
            self.ventana = Ui_ConcordancePreferences()
            self.ventana.setupUi(self)
    class CollocatesPreferences(QtGui.QWidget):
        def __init__(self,parent,task=None):
            QtGui.QWidget.__init__(self,parent)
            self.ventana = Ui_CollocatesPreferences()
            self.ventana.setupUi(self)
    class WordListPreferences(QtGui.QWidget):
        def __init__(self,parent,task=None):
            QtGui.QWidget.__init__(self,parent)
            self.ventana = Ui_WordListPreferences()
            self.ventana.setupUi(self)

    def __init__(self):
        QtGui.QWidget.__init__(self)

        self.ventana = Ui_ToolPreferences()
        self.ventana.setupUi(self)
        self.concordancepreferenceswin = self.ConcordancePreferences(self.ventana.frame)
        self.collocatespreferenceswin = self.CollocatesPreferences(self.ventana.frame)
        self.wordlistpreferenceswin = self.WordListPreferences(self.ventana.frame)
        self.collocatespreferenceswin.hide()
        self.wordlistpreferenceswin.hide()
        self.ventana.listWidget.setFocus()


        self.connect(self.ventana.listWidget, QtCore.SIGNAL('currentRowChanged(int)'), self.changed)

    def changed(self,i):
        if i == 0:
            self.concordancepreferenceswin.show()
            self.collocatespreferenceswin.hide()
            self.wordlistpreferenceswin.hide()
        elif i == 1:
            self.concordancepreferenceswin.hide()
            self.collocatespreferenceswin.show()
            self.wordlistpreferenceswin.hide()
        elif i == 2:
            self.concordancepreferenceswin.hide()
            self.collocatespreferenceswin.hide()
            self.wordlistpreferenceswin.show()
        else:
            self.concordancepreferenceswin.hide()
            self.collocatespreferenceswin.hide()
            self.wordlistpreferenceswin.hide()
            print("error")
        
    
class AdvancedSearch(QtGui.QWidget):
    def __init__(self,main):
        QtGui.QWidget.__init__(self)

        self.cFrom = 0
        self.cTo = 0
        self.searchList = QTextDocument(None)
        
        self.ventana = Ui_AdvancedSearch()
        self.ventana.setupUi(self)
        self.ventana.searchTerm.setModel(main.searchTerm.model())
        self.ventana.searchTerm.setInsertPolicy(1)                  #Insertar nous valors a l'inici enlloc del final.
        self.ventana.termList.setLineWrapMode(0)                    #Nowrap. Les linies apareixen complertes. No les talla.
        self.ventana.termList.setDocument(self.searchList)

        self.connect(self.ventana.loadFileButton, QtCore.SIGNAL('clicked()'), self.loadAdvancedFile)
        self.connect(self.ventana.addContextButton, QtCore.SIGNAL('clicked()'), self.addContextWord)
        self.connect(self.ventana.contextFrom,QtCore.SIGNAL('valueChanged(int)'), self.manageCFrom)
        self.connect(self.ventana.contextTo,QtCore.SIGNAL('valueChanged(int)'), self.manageCTo)
        self.connect(self.ventana.applyButton,QtCore.SIGNAL('clicked()'), self.apply)
        self.connect(self.ventana.clearButton,QtCore.SIGNAL('clicked()'), self.clearSearchList)

        
    def clearSearchList(self):
        self.searchList.clear()

    def apply(self):
        searchWords.useSearchList = self.ventana.termListCheckbox.isChecked()
        searchWords.useContextWords = self.ventana.contextWordCheckbox.isChecked()
        searchWords.searchList = self.searchList.toPlainText().split("\n")
        searchWords.contextWords = []
        for word in range(self.ventana.contextWordList.count()):    #Per cada word de contextWordList posar-la a searchWords
            searchWords.contextWords.append(self.ventana.contextWordList.item(word).text())
        searchWords.contextFrom = self.ventana.contextFrom.value()
        if self.ventana.contextFrom.suffix() == "L":
            searchWords.contextFrom = searchWords.contextFrom * -1
        searchWords.contextTo = self.ventana.contextTo.value()
        if self.ventana.contextTo.suffix() == "L":
            searchWords.contextTo = searchWords.contextTo * -1
        self.close()

    def loadAdvancedFile(self):
        filename = QtGui.QFileDialog.getOpenFileName(self, 'Open file','','Text Files (*.txt);;HTML Files (*.html *.htm);;XML Files (*.xml);;AntConc Files (*.ant);;All Files (*.*)')
        inp = open(filename, encoding='utf-8')
        self.searchList.setPlainText(str(inp.read()))


    def addContextWord(self):
        text = self.ventana.contextWordLine.text()
        if not func.isWord(text):
            QMessageBox.warning (self, "Message", "The entry is not a valid word!", buttons = QMessageBox.Ok, defaultButton = QMessageBox.Ok)
        else:
            self.ventana.contextWordList.addItem(text)

    def manageCFrom(self, i):
        if(abs(self.cFrom)!=abs(i)):
            suffix = self.ventana.contextFrom.suffix()
            if(suffix=="L"):
                if(i>abs(self.cFrom)):
                    self.cFrom = self.cFrom + 1
                else:
                    self.cFrom = self.cFrom - 1
            else:
                if(i>abs(self.cFrom)):
                    self.cFrom = self.cFrom + 1
                else:
                    self.cFrom = self.cFrom - 1
            if(self.cFrom==1):
                self.ventana.contextFrom.setSuffix("R")
            if(self.cFrom==0):
                self.ventana.contextFrom.setSuffix("")
                self.ventana.contextFrom.setValue(0)
            if(self.cFrom==-1):
                self.ventana.contextFrom.setSuffix("L")
            if(self.cFrom<0):
                a = self.cFrom
                self.ventana.contextFrom.setValue(abs(a))
            #Control that To will never be more to the left than From
            if(self.cFrom>self.cTo):
                self.cTo = self.cFrom
                self.ventana.contextTo.setValue(self.ventana.contextFrom.value())
                self.ventana.contextTo.setSuffix(self.ventana.contextFrom.suffix())

    def manageCTo(self, i):
        if(abs(self.cTo)!=abs(i)):
            suffix = self.ventana.contextTo.suffix()
            if(suffix=="L"):
                if(i>abs(self.cTo)):
                    self.cTo = self.cTo + 1
                else:
                    self.cTo = self.cTo - 1
            else:
                if(i>abs(self.cTo)):
                    self.cTo = self.cTo + 1
                else:
                    self.cTo = self.cTo - 1
            if(self.cTo==1):
                self.ventana.contextTo.setSuffix("R")
            if(self.cTo==0):
                self.ventana.contextTo.setSuffix("")
                self.ventana.contextTo.setValue(0)
            if(self.cTo==-1):
                self.ventana.contextTo.setSuffix("L")
            if(self.cTo<0):
                a = self.cTo
                self.ventana.contextTo.setValue(abs(a))
            #Control that From will never be more to the right than To
            if(self.cTo<self.cFrom):
                self.cFrom = self.cTo
                self.ventana.contextFrom.setValue(self.ventana.contextTo.value())
                self.ventana.contextFrom.setSuffix(self.ventana.contextTo.suffix())
